'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var t = require('@babel/types');
var babelPluginMacros = require('babel-plugin-macros');
var helperModuleImports = require('@babel/helper-module-imports');

var macro = function macro(_ref) {
  var _references$useProxy;

  var references = _ref.references;
  (_references$useProxy = references.useProxy) == null ? void 0 : _references$useProxy.forEach(function (path) {
    var _path$parentPath$getF;

    var hook = helperModuleImports.addNamed(path, 'useSnapshot', 'valtio');
    var proxy = path.parentPath.get('arguments.0').node;
    if (!t.isIdentifier(proxy)) throw new babelPluginMacros.MacroError('no proxy object');
    var snap = t.identifier("valtio_macro_snap_" + proxy.name);
    path.parentPath.parentPath.replaceWith(t.variableDeclaration('const', [t.variableDeclarator(snap, t.callExpression(hook, [proxy]))]));
    var inRender = true;
    (_path$parentPath$getF = path.parentPath.getFunctionParent()) == null ? void 0 : _path$parentPath$getF.traverse({
      Identifier: function Identifier(p) {
        if (inRender && p.node !== proxy && p.node.name === proxy.name) {
          p.node.name = snap.name;
        }
      },
      Function: {
        enter: function enter() {
          inRender = false;
        },
        exit: function exit() {
          inRender = true;
        }
      }
    });
  });
};

var macro$1 = babelPluginMacros.createMacro(macro, {
  configName: 'valtio'
});

exports.default = macro$1;
