import { isIdentifier, identifier, variableDeclaration, variableDeclarator, callExpression } from '@babel/types';
import { createMacro, MacroError } from 'babel-plugin-macros';
import { addNamed } from '@babel/helper-module-imports';

const macro = ({
  references
}) => {
  var _references$useProxy;

  (_references$useProxy = references.useProxy) == null ? void 0 : _references$useProxy.forEach(path => {
    var _path$parentPath$getF;

    const hook = addNamed(path, 'useSnapshot', 'valtio');
    const proxy = path.parentPath.get('arguments.0').node;
    if (!isIdentifier(proxy)) throw new MacroError('no proxy object');
    const snap = identifier(`valtio_macro_snap_${proxy.name}`);
    path.parentPath.parentPath.replaceWith(variableDeclaration('const', [variableDeclarator(snap, callExpression(hook, [proxy]))]));
    let inRender = true;
    (_path$parentPath$getF = path.parentPath.getFunctionParent()) == null ? void 0 : _path$parentPath$getF.traverse({
      Identifier(p) {
        if (inRender && p.node !== proxy && p.node.name === proxy.name) {
          p.node.name = snap.name;
        }
      },

      Function: {
        enter() {
          inRender = false;
        },

        exit() {
          inRender = true;
        }

      }
    });
  });
};

var macro$1 = createMacro(macro, {
  configName: 'valtio'
});

export default macro$1;
